﻿/*
 * Created by SharpDevelop.
 * User: phil
 * Date: 2010.12.30.
 * Time: 14:33
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;

namespace TetheredSun.Medical
{
	/// <summary>
	/// Description of SuccessiveDifferenceParameter.
	/// </summary>
	public abstract class SuccessiveDifferenceParameter : SequenceParameter
	{
		public double Evaluate(IList<double> intervals, out double[] successiveDifferences)
		{
			if ((intervals == null) || (intervals.Count < 2)) {
				successiveDifferences = null;
				value = Double.NaN;
				return value;
			}
			
			successiveDifferences = new double[intervals.Count - 1];
			
			for (int i = 1; i < intervals.Count; i++) {
				successiveDifferences[i - 1] = intervals[i] - intervals[i - 1];
			}
			
			return Evaluate(successiveDifferences);
		}
	}
}
